#ifndef CoCoA_decimal_H
#define CoCoA_decimal_H

//   Copyright (c)  2011  John Abbott

//   This file is part of the source of CoCoALib, the CoCoA Library.

//   CoCoALib is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.

//   CoCoALib is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with CoCoALib.  If not, see <http://www.gnu.org/licenses/>.
//   -------------------------------------------------------------------------


#include "CoCoA/ZZ.H"

#include <iosfwd>
//using std::ostream;
#include <string>

namespace CoCoA
{

  class QQ; // fwd decl -- defined in QQ.H

  class MantExp
  {
  public:
    MantExp(int s, long e, const ZZ& m): sign(s), exponent(e), mantissa(m) {}
    int sign;
    long exponent;
    ZZ mantissa;
  };

  std::ostream& operator<<(std::ostream& out, const MantExp& ME);

  MantExp MantissaAndExponent(const ZZ& N, const MachineInteger& SigFig);
  MantExp MantissaAndExponent(const QQ& N, const MachineInteger& SigFig);

  std::string FloatStr(const ZZ& N, const MachineInteger& SigFig = 5);
  std::string FloatStr(const QQ& q, const MachineInteger& SigFig = 5);

} // end of namespace CoCoA



// RCS header/log in the next few lines
// $Header: /Volumes/Home_1/cocoa/cvs-repository/CoCoALib-0.99/include/CoCoA/decimal.H,v 1.1 2011/03/01 15:21:22 abbott Exp $
// $Log: decimal.H,v $
// Revision 1.1  2011/03/01 15:21:22  abbott
// Added new functions: MantissaAndExponent, FloatStr (in CoCoALib).
//
//

#endif
